<template>
  <div
    class="order-lot-history"
    :class="[
      'order-lot-history--' + (currentStatus.code ? currentStatus.code.toLowerCase() : 'default')
    ]"
  >
    <button
      class="order-lot-history__close"
      @click="setVisibleLotHistory(false)"
    >
      <i class="icon close" />
    </button>
    <template v-if="isError">
      <div class="order-lot-history__error">{{ currentError }}</div>
    </template>
    <template v-else>
      <div class="order-lot-history__header">
        <div class="order-lot-history__title">
          {{ currentStatus.title }}
        </div>
        <div class="order-lot-history__info">
          <div class="item">
            <i class="icon profile-eye" />
            <span>10</span>
          </div>
          <div class="item">
            <i class="icon auction" />
            <span>{{ lotHistoryData.bidsCount }}</span>
          </div>
          <div
            v-if="isProcessed"
            class="item"
          >
            <ObCountdown
              :isIcon="true"
              :to-date="lotHistoryData.completionDt"
            />
          </div>
        </div>
        <div class="order-lot-history__detail">
          <div class="title">{{ bidTitle }}</div>
          <div class="price">{{ ((isExistBids ? lotHistoryData.bestBidAmount && lotHistoryData.bestBidAmount.priceWithVat : lotHistoryData.totalPrice) / 100) | currency({ dot: 2 }) }} ₽</div>
          <div
            v-if="isExistBids"
            class="nds"
          >
            <template v-if="bestBid.isVatPayer">
              + НДС {{ (bestBid.vatValue / 100) | currency({ dot: 2 }) }} ₽
            </template>
            <template v-else>
              Эта ставка НДС не облагается
            </template>
          </div>
        </div>
        <div class="order-lot-history__bids-info">
          Ставки выводятся без НДС
        </div>
      </div>
      <div class="order-lot-history__list">
        <template v-if="bids().length">
          <div
            v-for="(bid, index) in bids()"
            :key="index"
            class="item"
          >
            <div class="item__left">
              <span class="time">{{ bid.biddingDt | date('HH:mm') }}</span>
              <span class="date">{{ bid.biddingDt | date('DD.MM.YY') }}</span>
            </div>
            <div class="item__right">
              <span class="price">{{ (bid.bid / 100) | currency({ dot: 2 }) }} ₽</span>
              <span class="executor">{{ bid.participantTitle }}</span>
            </div>
          </div>
        </template>
        <template v-else>
          <div class="order-lot-history__list-empty">
            Здесь пока нет<br>ни одной ставки
          </div>
        </template>
      </div>
    </template>
  </div>
</template>

<script>
import { mapGetters, mapActions, mapMutations } from 'vuex'
import STEPS from '@/constants/steps.js'
import ObCountdown from 'common-components/src/obComponents/obCountdown'

const STATUS_MAP = {
  [STEPS.ACTIVE]: {
    code: STEPS.ACTIVE,
    title: 'Идет Аукцион',
    bidTitle: (isExistBids) => isExistBids ? 'Лучшая ставка' : 'Начальная ставка'
  },
  [STEPS.COMPLETED]: {
    code: STEPS.COMPLETED,
    title: 'Аукцион завершен',
    bidTitle: (isExistBids) => isExistBids ? 'Ставка, победившая в аукционе' : 'Начальная ставка'
  },
  [STEPS.CANCELLED]: {
    code: STEPS.CANCELLED,
    title: 'Аукцион отменен',
    bidTitle: (isExistBids) => isExistBids ? 'Ставка, победившая в аукционе' : 'Начальная ставка'
  }
}

export default {
  name: 'OrderLotHistory',
  components: {
    ObCountdown
  },
  data () {
    return {}
  },
  watch: {
    'currentOrder.uuid': {
      immediate: true,
      handler (value) {
        if (value) {
          this.getLotHistory({
            uuid: value,
            routeCategory: this.currentOrder.suborderSpecies.routeCategory
          })
        }
      }
    }
  },
  computed: {
    ...mapGetters({
      order: 'order/order',
      isMainLoading: 'order/isLoading',
      lotHistory: 'order/lotHistory',
      selectedSubOrder: 'order/selectedSubOrder'
    }),
    lotHistoryData () {
      return this.lotHistory || {}
    },
    currentOrder () {
      return this.order.isSuborder ? this.order : this.selectedSubOrder || {}
    },
    isError () {
      return Boolean(this.lotHistoryData.error)
    },
    currentError () {
      return this.lotHistoryData.error
    },
    currentStatus () {
      return STATUS_MAP[this.lotHistoryData.status] || {}
    },
    isProcessed () {
      return this.currentStatus.code === STEPS.ACTIVE
    },
    bestBid () {
      return this.isExistBids && this.bids().sort((a, b) => a.bid - b.bid)[0] || {}
    },
    isExistBids () {
      return Boolean(this.bids().length)
    },
    bestBidPrice () {
      return this.bestBid ? (this.isVatPayer ? this.bestBid.bid + this.bestBid.vatValue : this.bestBid.bid) : null
    },
    isVatPayer () {
      return this.bestBid ? this.bestBid.isVatPayer : false
    },
    bidTitle () {
      return this.currentStatus.bidTitle && this.currentStatus.bidTitle(this.isExistBids)
    }
  },
  methods: {
    ...mapActions({
      getLotHistory: 'order/getLotHistory'
    }),
    ...mapMutations({
      setVisibleLotHistory: 'order/setVisibleLotHistory'
    }),
    bids () {
      return this.lotHistoryData.bidsDetails || []
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .order-lot-history {
    position: absolute;
    z-index: 100;
    top: 0;
    right: 0;
    width: 338px;
    height: 100%;
    display: flex;
    flex-direction: column;
    padding-top: 38px;
    background-color: #fff;
    box-shadow: 0px 2px 10px rgba(0, 112, 166, 0.15);
    &__error {
      padding: 50px 30px;
      color: $light-raspberry-red;
      text-align: center;
    }
    &__close {
      position: absolute;
      top: 25px;
      right: 23px;
      display: flex;
      justify-content: center;
      align-items: center;
      padding: 0;
      border: none;
      background-color: transparent;
      outline: none;
      cursor: pointer;
      &:hover {
        opacity: 0.8;
      }
      i {
        font-size: 22px;
        color: $color-blue-navy-blue;
      }
    }
    &__header {
      display: flex;
      flex-direction: column;
      align-items: center;
      padding: 0 30px;
      text-align: center;
      flex-shrink: 0;
      position: relative;
      &::after {
        content: '';
        position: absolute;
        left: 0;
        opacity: 0.4;
        width: 100%;
        height: 4px;
        background: linear-gradient(180deg, rgba(196, 213, 237, 0.5) 0%, rgba(207, 222, 244, 0) 100%);
      }
      &::after {
        bottom: 0px;
      }
    }
    &__title {
      margin-bottom: 9px;
      @include font-mixin(10px, 16px, 400, $shale-gray, 1.6px, uppercase);
      .order-lot-history--completed & {
        color: $Green-700;
      }
      .order-lot-history--cancelled & {
        color: $color-error;
      }
    }
    &__info {
      display: flex;
      align-items: center;
      margin-bottom: 24px;
      .item + .item {
        margin-left: 11.5px;
      }
      .item {
        display: flex;
        align-items: center;
        @include font-mixin(14px, 12px, 400, $color-text-base, 0.4px);
        i {
          color: $color-blue-navy-blue;
        }
        span {
          padding-left: 3.6px;
        }
      }
      &::v-deep {
        .ob-countdown .icon {
          margin-right: 3.6px;
          font-size: 14px;
        }
      }
    }
    &__detail {
      .title {
        @include font-mixin(10px, 16px, 400, $shale-gray, 1.6px, uppercase);
        .order-lot-history--completed & {
          color: $Green-700;
        }
        .order-lot-history--cancelled & {
          color: $color-error;
        }
      }
      .price {
        opacity: 0.9;
        @include font-mixin(24px, 36px, 600, $color-text-base, 0.2px);
        .order-lot-history--completed & {
          color: $Green-700;
        }
        .order-lot-history--cancelled & {
          color: $color-error;
        }
      }
      .nds {
        @include font-mixin(10px, 12px, 400, $gray-slate, 0.4px);
      }
    }
    &__bids-info {
      margin-top: 35px;
      margin-bottom: 16px;
      @include font-mixin(10px, 12px, 400, $gray-slate, 0.4px);
    }
    &__list-empty {
      padding: 20px 20px 30px 20px;
      opacity: 0.6;
      text-align: center;
      @include font-mixin(24px, 36px, 400, $color-grey-label, 0.4px);
    }
    &__list {
      overflow-y: auto;
      position: relative;
      padding: 10px 0 30px 0;
      &::after {
        content: '';
        display: block;
        opacity: 0.4;
        width: 100%;
        height: 4px;
        background: linear-gradient(180deg, rgba(196, 213, 237, 0.5) 0%, rgba(207, 222, 244, 0) 100%);
      }
      &::after {
        transform: rotate(180deg);
      }
      .item {
        display: flex;
        align-items: center;
        padding: 10px 30px;
        cursor: pointer;
        &:hover {
          background-color: #EAF5FA;
        }
        &__left, &__right {
          display: flex;
          flex-direction: column;
        }
        &__left {
          margin-right: 20px;
          @include font-mixin(12px, 20px, 400, $color-text-base);
          .time {}
          .date {
            color: $gray-slate;
          }
        }
        &__right {
          flex-grow: 2;
          @include font-mixin(14px, 20px, 400, $color-text-base);
          .price {}
          .executor {
            color: $color-blue-navy-blue;
          }
        }
      }
    }
  }
</style>
